searchNodes=[{"doc":"The library's main moduleThis module should be used as the public entrypoint of the library. It exposes a single function, parse/2, which is used to parse a lockfile's contents.Note on performance: This library was built in part as a learning exercise and therefore does not necessarily apply the best possible practices and tools when it comes to code quality and performance. If performance is important to you, I recommend using Dorgan's library (hex.pm, Github), which uses NimbleParsec for better performance.ExampleGiven the following yarn.lock file:foo: &quot;bar&quot; true foo 10 foobar: barfoo The module should be used in the following manner:iex&gt; {:ok, input} = File.read(&quot;yarn.lock&quot;) iex&gt; ExYarn.parse(input, &quot;yarn.lock&quot;) {:ok, :success, %{&quot;foo&quot; =&gt; %{&quot;bar&quot; =&gt; true, &quot;foo&quot; =&gt; 10, &quot;foobar&quot; =&gt; &quot;barfoo&quot;}}}","ref":"ExYarn.html","title":"ExYarn","type":"module"},{"doc":"Receives the lockfile's contents, and optionnally the lockfile's name as inputs and returns the parse resultThe lockfile's name is used to determine whether to parse the lockfile as an official yarn lockfile (i.e. with yarn's custom format) or as a regular YAML file. The function defaults to parsing the file as a yarn lockfile.","ref":"ExYarn.html#parse/2","title":"ExYarn.parse/2","type":"function"},{"doc":"The possible return values of parse/2Types details:{:ok, :merge, map()}: The lockfile contained a merge conflict but was still successfully parsed{:ok, :success, map()}: The locfile was successfully parsed{:error, _}: There was an error while parsing the lockfile. The second element indicates the type of error that occured{:error, :conflict, FunctionClauseError}: The lockfile contained a merge conflict which could not be parsed successfully.","ref":"ExYarn.html#t:parseResult/0","title":"ExYarn.parseResult/0","type":"type"},{"doc":"Represents an error that has occured while parsing a lockfile.An error contains an error message and, if possible, the ExYarn.Token that caused the error.","ref":"ExYarn.ParseError.html","title":"ExYarn.ParseError","type":"module"},{"doc":"Returns a new ExYarn.ParseError","ref":"ExYarn.ParseError.html#new/2","title":"ExYarn.ParseError.new/2","type":"function"},{"doc":"A parsing errorError content::error: A String explaining what went wrong:token: If available, the ExYarn.Token that caused the error","ref":"ExYarn.ParseError.html#t:t/0","title":"ExYarn.ParseError.t/0","type":"type"},{"doc":"Main module for parsing lockfiles (intended for internal use only)This module receives the lockfile as input, passes it over to ExYarn.Token for tokenization and parses the resulting token list to generate the map reprsenting the lockfile's contents.","ref":"ExYarn.Parser.html","title":"ExYarn.Parser","type":"module"},{"doc":"The module's entrypointReceives the lockfile's content as a String and returns the parsed map representing the lockfile as a Map.","ref":"ExYarn.Parser.html#parse/1","title":"ExYarn.Parser.parse/1","type":"function"},{"doc":"This type is meant for internal use only and reprsents the parser's state","ref":"ExYarn.Parser.html#t:t/0","title":"ExYarn.Parser.t/0","type":"type"},{"doc":"A token is the building block of a lockfile (intended for internal use only)This module takes a lockfile's contents as input and breaks it up into a list of tokens, each of them representing a single discrete element of the lockfile.Tokens represent every piece that makes up a lockfile, from comments, strings and integers to line returns, colons and indentation.","ref":"ExYarn.Token.html","title":"ExYarn.Token","type":"module"},{"doc":"Main entrypoint for the module. Takes as input a String representing the contents of a yarn lockfile and returns the corresponding list of tokens.","ref":"ExYarn.Token.html#tokenize/1","title":"ExYarn.Token.tokenize/1","type":"function"},{"doc":"Takes a ExYarn.Token as an input and returns a boolean indicating whether or not it can be used as a value for a key","ref":"ExYarn.Token.html#valid_prop_value?/1","title":"ExYarn.Token.valid_prop_value?/1","type":"function"},{"doc":"A token represents a discrete piece of text making up a lockfile","ref":"ExYarn.Token.html#t:t/0","title":"ExYarn.Token.t/0","type":"type"},{"doc":"The list of types a token can have","ref":"ExYarn.Token.html#t:tokenType/0","title":"ExYarn.Token.tokenType/0","type":"type"},{"doc":"ExYarnThis is a simple library for parsing Yarn lockfiles. This is currently a mostly direct port of Yarn's own parser, so it's very imperative-like in many places. I do plan to improve this and make better use of Elixir and OTP's features and ecosystem in the future.Note on performance: This library was built in part as a learning exercise and therefore does not necessarily apply the best possible practices and tools when it comes to code quality and performance. If performance is important to you, I recommend using Dorgan's library (hex.pm, Github), which uses NimbleParsec for better performance.","ref":"readme.html","title":"ExYarn","type":"extras"},{"doc":"The package can be installed by adding ex_yarn to your list of dependencies in mix.exs:def deps do [ {:ex_yarn, &quot;~&gt; 0.3.1&quot;} ] end","ref":"readme.html#installation","title":"ExYarn - Installation","type":"extras"},{"doc":"Documentation is generated with ExDoc and is published at https://hexdocs.pm/ex_yarn.","ref":"readme.html#documentation","title":"ExYarn - Documentation","type":"extras"},{"doc":"[x] Write documentation.[ ] Wrap the parser's output in a struct to make actual usage of the library easier.[ ] Improve code quality (this will obviously be an ongoing goal, but credo should at least run without errors for this to be considered &quot;completed&quot;).[ ] Consider using NimbleParsec to replace the parser for better maintainability and performance.","ref":"readme.html#todos","title":"ExYarn - TODOs","type":"extras"}]